//+------------------------------------------------------------------+
//|                                             LastQuotesWriter.mq4 |
//|                                                         StSpirit |
//|                                         maksim-working@yandex.ru |
//+------------------------------------------------------------------+
#property copyright "StSpirit"
#property link      "maksim-working@yandex.ru"
#property show_inputs

extern string Pairs = "EURUSD;EURJPY;USDCHF;GBPUSD;GBPJPY;USDCAD;CADJPY;AUDUSD;NZDUSD;NZDJPY;USDJPY";
extern string FileName = "Ticker";
extern int Pause = 5;
int digits = 0;
string aPairs[];

void WritingLineInFile(string text, int number)
   {
   int file=FileOpen(FileName+".txt", FILE_READ|FILE_WRITE, " "); 
   if (file>0)
      {
      FileSeek(file, 0, SEEK_END);
      FileWrite(file, text);
      FileClose(file);
      }
   }

string StringUpperCase(string str)
   {
   string s = str;
   int lenght = StringLen(str) - 1;
   int char;
   while(lenght >= 0)
      {
       char = StringGetChar(s, lenght);
       if((char > 96 && char < 123) || (char > 223 && char < 256)) s = StringSetChar(s, lenght, char - 32);
       else 
           if(char > -33 && char < 0) s = StringSetChar(s, lenght, char + 224);
           lenght--;
      }
   return(s);
}

bool IsMini()
{
   if (StringFind(Symbol(),"m") > -1) return(true);
   else return(false);    
}
//+------------------------------------------------------------------+
//| script program start function                                    |
//+------------------------------------------------------------------+
int start()
  {
  Pairs = StringUpperCase(StringTrimLeft(StringTrimRight(Pairs)));
  if (StringSubstr(Pairs,StringLen(Pairs),1) != ";")
  Pairs = StringConcatenate(Pairs,";");
  bool isMini = IsMini();            
  int s = 0;
  int i = StringFind(Pairs,";",s);
  string current;
  while (i > 0)
     {
     current = StringSubstr(Pairs,s,i-s);
     if (isMini) current = StringConcatenate(current,"m");
     if (iClose(current,0,0) > 0)
        {
        ArrayResize(aPairs,ArraySize(aPairs)+1);
        aPairs[ArraySize(aPairs)-1] = current;
        }
        s = i + 1;
        i = StringFind(Pairs,";",s);
    }
  
  int l=0;
  while(l<1)
   {
   for(int x=0; x<ArraySize(aPairs); x++)
      {
      string str =  "|       " + aPairs[x] + ": " + DoubleToStr(MarketInfo(aPairs[x],MODE_BID),MarketInfo(aPairs[x],MODE_DIGITS)) + "       |";
      WritingLineInFile(str,x);
      }
   Sleep(Pause*1000);
   FileDelete(FileName+".txt"); 
   }
   return(0);
  }
//+------------------------------------------------------------------+